/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>
#include <cmath>

using namespace std;

int first(int n)
{
    int i = 2;
    while(n % i != 0)
    {
        if(i > n / 2 + 1)
            return 0;
        else
            i++;
    }
    return i;
}

bool Sx(int n)
{
    int f = first(n);
    if(!f)
        return false;
    int next = n / f;
    if(f * f == n)
        return true;
    int f2 = f;
    for(;;)
    {
        f2 = first(next);
        if(f2 == f)
            return true;
        else if(!f2)
            return false;
        if(f2 != f)
            return false;
        next = next / f;
    }
}

int main()
{
    int n;
    ifstream in;
    in.open("numbers.in");
    in >> n;
    in.close();
    int l = 0;
    for(int i = 3;i < n + 1;i++)
        if(Sx(i))
            l++;
    ofstream out;
    out.open("numbers.out");
    out << l + 1;
    out.close();
    return 0;
}

