import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Scanner;

public class table {

	public static void main(String[] args) {
		try (Scanner scanner = new Scanner(new File("table.in"));
				BufferedOutputStream output = new BufferedOutputStream(new FileOutputStream(new File("table.out"))))
			{
				int n = scanner.nextInt();

				int[][] table = new int[n][n];
				
				for (int i = 0; i < n; i++) {
					for (int j = 0; j < n; j++) {
						table[i][j] = scanner.nextInt();
					}
				}
				
				output.write(((recurs(new int[2 * table.length - 1], table, 0, 0, 0) % 101) + "\n").getBytes());

			} catch (IOException e)
			{
				e.printStackTrace();
			}
	}
	
	private static int recurs(int[] way, int[][] table, int x, int y, int id) {		
		way[id] = table[y][x];
		
		if (id >= table.length && way[id] != way[way.length - 1 - id])
			return 0;
			
		if (id > way.length)
		{
			return 1;
		}
		
		int count = 0;
		
		id++;
		
		if (x < table.length - 1)
		{
			way[id] = table[y][x + 1];
			count += recurs(way, table, y, x + 1, id);
		}
		
		if (y < table.length - 1)
		{
			way[id] = table[y + 1][x];
			count += recurs(way, table, y + 1, x, id);
		}
		
		return count;
	}
}
