/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>

using namespace std;

ifstream in("polyline.in");
ofstream out("polyline.out");

struct coor
{
    long double y,x;
    int num;
};

int n;
long double mainX,mainY;
coor a[10000];

void qsort(coor a[],int left,int right)
{
    int i=left,j=right;
    long double mid=a[(left+right)/2].y;
    while(i<=j)
    {
        while(a[i].y<mid)
            i++;
        while(a[j].y>mid)
            j--;
        if(i<=j)
        {
            swap(a[i],a[j]);
            i++;
            j--;
        }
    }
    if(i<right)
        qsort(a,i,right);
    if(left<j)
        qsort(a,left,j);
}

int main()
{
    in>>n;
    for(int i=0;i<n;i++)
    {
        int tx,ty;
        in>>tx>>ty;
        a[i].x=tx;
        a[i].y=ty;
        a[i].num=i;
    }
    long double disX=(a[n-1].x+a[n-2].x)/2.0,disY=(a[n-1].y+a[n-2].y)/2.0;
    mainX=a[n-1].x+disX+0.001;
    mainY=a[n-1].y+disY+0.001;
    for(int i=0;i<n;i++)
    {
        a[i].x-=mainX;
        a[i].y-=mainY;
        a[i].num=i;
    }
    qsort(a,0,n-1);
    for(int i=0;i<n;i++)
    {
        if(a[i].x>=0)
        {
            out<<a[i].num+1<<" ";
        }
    }
    for(int i=n-1;i>=0;i--)
    {
        if(a[i].x<0)
        {
        out<<a[i].num+1<<" ";
        }
    }
    out<<endl;
    in.close();
    out.close();
    return 0;
}
