/* GCC */
#include<fstream>
#include<cmath>
using namespace std;

int arr[10000];
int path[199];
int n;

void set(int x, int y, int num){
    arr[n*y + x] = num;
}

int get(int x, int y){
    return arr[n*y + x];
}

int rec(int x, int y, int step){
    if(step<n){
        if(step > 0)
            path[step] = get(x, y);

        else if(get(x, y) != path[-step])
            return 0;
    }
    if(step == n) step = -step;
    int sum = 0;
    if(x<n-1){
        sum += rec(x+1, y, step+1);
    }
    if(y<n-1){
        sum += rec(x, y+1, step+1);
    }
    else if(x>=n-1){
        return 1;
    }
    return sum;
}

int main(){
    ifstream in;
    ofstream out;
    in.open("table.in");
    out.open("table.out");
    int k, pathes = 0;
    in>>n;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            in>>k;
            set(i, j, k);
        }
    }
    if(get(0,0) == get(n-1,n-1)) pathes = rec(0, 0, 1);
    out<<pathes%101<<endl;
    out.close();
    in.close();
    return 0;
}

