/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>
#define NUMCNT 11

using namespace std;
size_t nums[NUMCNT] = {1, 4, 16, 65536};

int main(void)
{
    ios_base::sync_with_stdio(false);
    for(size_t i = 3; i < 10; ++i)
    {
        nums[i + 1] = 1;
        for(size_t j = 0; j < i; ++j)
            nums[i + 1] *= i;
    }
    size_t n;
    sort(nums, nums + NUMCNT);
    ifstream in("numbers.in");
    in >> n;
    in.close();
    ofstream out("numbers.out");
    out << upper_bound(nums, nums + NUMCNT, n) - nums << '\n';
    out.close();
    return 0;
}
