/* GCC */
#include <iostream>
#include <fstream>

using namespace std;
int n, table[200][200] = {}, dp[100][200][200] = {}; // [ui][uj][dj]
int nui, ndi, nuj, ndj;
const int dDj[2] = {-1, 0}, uDj[2] = {0, 1};

int main(void)
{
    ios_base::sync_with_stdio(false);
    ifstream in("table.in");
    in >> n;
    for(int i = 0; i < n; ++i)
        for(int j = 0; j < n; ++j)
            in >> table[i + j][j];
    in.close();
    for(int j = 0; j < n; ++j)
        dp[n - 1][j][j] = 1;
    for(int ui = n - 2; ui >= 0; --ui)
    {
        const int di = (n << 1) - 2 - ui;
        for(int uj = 0; uj <= ui; ++uj)
            for(int dj = di - (n - 1); dj < n; ++dj)
                if(uj <= dj && table[ui][uj] == table[di][dj])
                {
                    nui = ui + 1, ndi = di - 1;
                    for(int uDj_idx = 0; uDj_idx < 2; ++uDj_idx)
                        for(int dDj_idx = 0; dDj_idx < 2; ++dDj_idx)
                        {
                            nuj = uj + uDj[uDj_idx], ndj = dj + dDj[dDj_idx];
                            (dp[ui][uj][dj] += dp[nui][nuj][ndj]) %= 101;
                        }
                }
    }
    ofstream out("table.out");
    out << dp[0][0][n - 1] << '\n';
    out.close();
    return 0;
}
