/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, i, a, b, c, p[2030];
vector < pair < pair <int, int> , int> > v;
bool flag1, flag2;
vector <int> ans;

int main()
{
    freopen("polyline.in", "r", stdin);
    freopen("polyline.out", "w", stdout);

    scanf("%d", &n);
    v.resize(n);
    for(i = 0; i < n; i++)
    {
        scanf("%d %d", &v[i].X.X, &v[i].X.Y);
        v[i].Y = i;
    }

    sort(v.begin(), v.end());

    a = v[n - 1].X.Y - v[0].X.Y;
    b = v[0].X.X - v[n - 1].X.X;
    c = (-a) * v[0].X.X + (-b) * v[0].X.Y;
    //cerr << a << " " << b << " " << c << endl;

    flag1 = flag2 = false;
    for(i = 1; i < n - 1; i++)
        if((a * v[i].X.X + b * v[i].X.Y + c) < 0)
        {
            flag1 = true;
            p[i] = 1;
        }
        else if((a * v[i].X.X + b * v[i].X.Y + c) > 0)
        {
            flag2 = true;
            p[i] = -1;
        }
        else
            p[i] = 0;

    if(flag1 == false && flag2 == false)
    {
        printf("0\n");
        return 0;
    }

    for(i = 1; i < n - 1; i++)
        if(p[i] == 0)
        {
            if(flag1 == true)
                p[i] = -1;
            else
                p[i] = 1;
        }

    for(i = 0; i < n; i++)
        if(p[i] == 1 || p[i] == 0)
            ans.push_back(v[i].Y + 1);

    for(i = n - 1; i >= 0; i--)
        if(p[i] == -1)
            ans.push_back(v[i].Y + 1);

    for(i = 0; i < n - 1; i++)
        printf("%d ", ans[i]);
    printf("%d\n", ans[n - 1]);

    return 0;
}




















