/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
//#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

vector < vector < vector <int> > > v;
int a[110][110], n, i, j, k, x, y, d;
int m = 101;

int dist(int b, int c)
{
    return (n - 1 - b - c) * 2;
}

int proc1(int b, int c)
{
    return min(n - 1 - c, dist(b, c)) + 1;
}

int main()
{
    freopen("table.in", "r", stdin);
    freopen("table.out", "w", stdout);

    scanf("%d", &n);
    for(i = 0; i < n; i++)
        for(j = 0; j < n; j++)
            scanf("%d", &a[i][j]);

    v.resize(n);
    for(i = 0; i < n; i++)
    {
        v[i].resize(n - i);
        for(j = 0; j < n - i; j++)
            v[i][j].resize(proc1(i, j), 0);
    }

    for(i = n - 1; i >= 0; i--)
        v[i][n - 1 - i][0] = 1;

    for(i = n - 2; i >= 0; i--)
        for(j = n - i - 2; j >= 0; j--)
        {
            //D
            for(k = 0; k < v[i + 1][j].size(); k++)
            {
                d = dist(i + 1, j);
                x = i + 1 + d - k;
                y = j + k;

                if(x >= n)
                    continue;

                if(x + 1 < n)
                {
                    if(a[x + 1][y] == a[i][j])
                        v[i][j][k] = (v[i][j][k] + v[i + 1][j][k]) % m;
                }

                if(y + 1 < n)
                {
                    if(a[x][y + 1] == a[i][j])
                        v[i][j][k + 1] = (v[i][j][k + 1] + v[i + 1][j][k]) % m;
                }
            }

            //R

            for(k = 0; k < v[i][j + 1].size(); k++)
            {
                d = dist(i, j + 1);
                x = i + d - k;
                y = j + 1 + k;

                if(x >= n)
                    continue;

                if(x + 1 < n)
                {
                    if(a[x + 1][y] == a[i][j])
                        v[i][j][k + 1] = (v[i][j][k + 1] + v[i][j + 1][k]) % m;
                }

                if(y + 1 < n)
                {
                    if(a[x][y + 1] == a[i][j])
                        v[i][j][k + 2] = (v[i][j][k + 2] + v[i][j + 1][k]) % m;
                }
            }
        }

    i = j = d = 0;
    for(k = 0; k < v[i][j].size(); k++)
        d = (d + v[i][j][k]) % m;

    printf("%d\n", d);

    return 0;
}




















