/* GCC */

#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

long long pown(long long a, long long n)
{
    if (n == 0)
        return 1;
    if (n == 1)
        return a;
    if (n % 2 == 1)
        return pown(a, n - 1) * a;

    long long x = pown(a, n / 2);
    return x * x;
}

int main()
{
    freopen("numbers.in", "r", stdin);
    freopen("numbers.out", "w", stdout);
    //ios::sync_with_stdio(false);

    long n;
    cin >> n;

    long cnt = 1;

    if (16 <= n)
        ++cnt;

    if (65536 <= n)
        ++cnt;

    for (long i = 2; i <= 9; ++i)
        if (pown(i, i) <= n)
            ++cnt;

    cout << cnt;
    cout << endl;
    return 0;
}
