/* GCC */

#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

const double PI = 3.14159265;

struct point
{
    int n;
    double angle;
};

bool c(point a, point b)
{
    if (a.angle < b.angle)
        return true;
    return false;
}

int main()
{
    ifstream in;
    in.open("polyline.in", ios_base::in);
    ofstream out;
    out.open("polyline.out", ios_base::out);

    int n;
    in >> n;

    vector <point> a(n);
    int x, y;
    double angle;
    for (int i = 0; i < n; i++)
    {
        in >> x;
        in >> y;
        if (x == 0)
            if (y > 0)
                angle = PI/2;
            else
                angle = -PI/2;
        else
        {
            angle = atan( y/(1.0*x) );
            if (x < 0)
                if (y > 0)
                    angle += PI;
                else
                    angle -= PI;
        }
        a[i].n = i + 1;
        a[i].angle = angle;
    }

    sort(a.begin(), a.end(), c);

    out << a[0].n;
    for (int i = 1; i < n; i++)
        out << " " << a[i].n;
    out << endl;
    in.close();
    out.close();
    return 0;
}
