/* GCC */

#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>

using namespace std;

// define methods
int DefineMaxPower(int n);
bool IsBasePrime(int base);

// entry point
int main()
{
	freopen("numbers.in","r",stdin);
	freopen("numbers.out","w",stdout);

	int n;
	int result = 1;
	cin >> n;

	int maxBase = sqrt(n);
	int maxPower = DefineMaxPower(n);
	for (int base = 2; base <= maxBase; base++)
        for (int power = 2; power <= maxPower; power++)
            if (IsBasePrime(base))
                if (pow(base,power) <= n)result++;


    //cout << "max base: " << maxBase << " max pow: " << maxPower << endl;
    cout << result;
	return 0;
}

int DefineMaxPower(int n)
{
    int pow = 0;
    double tmp = n;
    while (tmp >= 2) {pow++; tmp /= 2;}
    return pow;
}

bool IsBasePrime(int base)
{
    for (int i = 2; i <= sqrt(base); i++)
        if (base % i == 0) return false;
    return true;
}

