/* GCC */

#include<iostream>
#include<fstream>
#include<vector>

using namespace std;

int maxlen(vector<int> &x, vector<int> &y)
{
    int ite=0;
    for(int i=0; i<x.size(); i++)
    {
        if(x[i]*x[i]+y[i]*y[i]>x[ite]*x[ite]+y[ite]*y[ite]) ite=i;
    }
    return ite;
}

int len(int x1,int y1, int x2, int y2)
{
    int l=(x2-x1)*(x2-x1)+(y2-y1)*(y2-y1);
    return l;
}
void minl(vector<int> &x, vector<int> &y, int i1, int &i2, vector<int> &z)
{
    int lmin=len(x[i1],y[i1],x[0],y[0]);
    for(int i=0; i<x.size(); i++) if(len(x[i1],y[i1],x[0],y[0])>len(x[i1],y[i1],x[i],y[i]) && z[i]==0) i2=i;
}
int bit(vector<int> &x, vector<int> &y)
{
    int ite=0;
    for(int i=0; i<x.size(); i++)
    {
        if(x[i]*x[i]+y[i]*y[i]<x[ite]*x[ite]+y[ite]*y[ite]) ite=i;
    }
    return ite;
}

int main()
{
    ifstream fin("polyline.in");
    ofstream fout("polyline.out");

    int n;
    fin>>n;

    vector<int> x(n,0);
    vector<int> y(n,0);
    vector<int> z(n,0);

    for(int i=0; i<n; i++) fin>>x[i]>>y[i];

    vector<int> out;

    int dalt=maxlen(x,y);
    out.push_back(dalt);

    int i2;
    z[dalt]=1;
    int blt=bit(x,y);
    while(i2!=blt)
    {
        minl(x,y,dalt,i2,z);
        z[i2]=1;
        dalt=i2;
        out.push_back(i2);
    }
    int y322=1;
    for(int i=0; i<n; i++) if(z[i]==0) {cout<<"0"<<endl; break; y322=0;}
    if(y322==1)
    {
        for(int g=0; g<out.size(); g++) cout<<out[g]<<' ';
    }
    cout<<endl;
    return 0;
}

