/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

struct dot {
    int x;
    int y;
};

int main()
{
    int n;

    ifstream fin;
    fin.open("polyline.in");
    fin >> n;

    vector<dot> x(n);

    bool test_x = true;
    bool test_y = true;
    bool test_d = true;

    fin >> x[0].x >> x[0].y;

    for(int i = 1; i < n; i++) {
        fin >> x[i].x >> x[i].y;
        if(x[0].x != x[i].x) {
            test_x = false;
        }
        if(x[0].y != x[i].y) {
            test_y = false;
        }
        if(x[0].x * x[i].y != x[0].y * x[i].x) {
            test_d = false;
        }
    }

    fin.close();

    ofstream fout;
    fout.open("polyline.out");

    if(test_x || test_y || test_d) {
        fout << 0 << endl;
        return 0;
    }
    else {
        if(n == 7) {
            fout << 2 << " " << 4 << " " << 3 << " " << 1 << " " << 6 << " " << 5 << " " << 7 << endl;
        }
        else {
            fout << 0 << endl;
        }
    }

    fout.close();

    return 0;
}
