-O2 -static -lm %file -o %exe
/* GCC */
#include <iostream>
#include <string>
using namespace std;
bool IsPalindrome(int w[], int n)
{
    for (int i = 0; i < n/2; i++)
    {
        if(w[i]!=w[n-i-1])
        {
            return false;
        }
    }
    return true;
}
struct Tqueue
{
    int way[10200];
    int curstep;
    int x;
    int y;
};
struct Tfield
{
    int f[110][110];
};

int NumOfWays(Tfield field, int n)
{
    int nOfWays = 0;
    Tqueue q[10200];
    int head = 0;
    int tail = 1;
    q[0].curstep = 0;
    q[0].way[0] = field.f[0][0];
    q[0].x = 0;
    q[0].y = 0;
    while(head!=tail)
    {
    if ((q[head].x == n-1)&&(q[head].y == n-1))
        {
            if((q[head].curstep == (2 * n)-2)&&IsPalindrome(q[head].way, (2 * n) - 1))
            {
                nOfWays++;
                head++;
            }
            else
            {
                Tqueue element;
                element.curstep = q[head].curstep;
                for(int i = 0; i <= q[head].curstep; i++)
                {
                    element.way[i] = q[head].way[i];
                }
                element.x = q[head].x;
                element.y = q[head].y;

                if(field.f[element.x + 1][element.y]!=-1)
                {
                        q[tail].curstep = element.curstep + 1;
                        q[tail].x = element.x + 1;
                        q[tail].y = element.y ;
                    for(int i = 0; i <= element.curstep; i++)
                {
                    q[tail].way[i] = element.way[i];
                }
                q[tail].way[element.curstep + 1] = field.f[element.x + 1][element.y];
                tail++;
                }
                if(field.f[element.x][element.y + 1]!=-1)
                {
                        q[tail].curstep = element.curstep + 1;
                        q[tail].x = element.x ;
                        q[tail].y = element.y +1 ;
                    for(int i = 0; i <= element.curstep; i++)
                {
                    q[tail].way[i] = element.way[i];
                }
                q[tail].way[element.curstep + 1] = field.f[element.x ][element.y + 1];
                tail++;
                }
                head++;
            }
        }
    }
    return numOfWays;

}

int main()
{
    freopen("table.in", "r", stdin);
    freopen("table.out", "w", stdout);

    int n;
    cin >> n;
    Tfield field;
    for(int i = 0; i < 110; i++)
    {
        for(int j = 0; j < 110; j++)
        {
             field.f[i][j] = -1;
        }
    }

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
             cin >> field.f[i][j] ;
        }
    }

    cout << NumOfWays(field, n) << endl;



    return 0;
}
