/* GCC */
#include <iostream>
#include <fstream>
#include <cstdlib>
#include <stdio.h>

using namespace std;

class table {
    int **arr;
    int sz;
    int *carr;
public:
    int palCnt;
    table();
    ~table();
    bool comp();
    void RECURSION(int x, int y, int step);

};

int main() {
    table t;
    t.RECURSION(0,0,1);
    return 0;
}

table::table(){
    palCnt = 0;
    FILE *f = fopen("table.in", "r");
    fscanf(f, "%d\n", &sz);
    carr = new int[(sz*2)-1];
    for(int i = 0; i < (sz*2)-1; i++)
        carr[i] = -1;
    arr = new int*[sz];
    for(int i = 0; i < sz; i++)
        arr[i] = new int[sz];
    for(int i = 0; i < sz; i++) {
        for(int j = 0; j < sz; j++)
            fscanf(f, "%d ", &arr[i][j]);
    }
    fclose(f);
}

table::~table() {
/*
    FILE* f = fopen("table.out", "w");
    fprintf(f, "%d", palCnt%101);
    fclose(f);
*/
    ofstream f;
    f.open("table.out");
    f << palCnt%101 << endl;
    f.close();
}

void table::RECURSION(int x, int y, int step) {
    if(step == (sz*2)) {
        palCnt = (comp()?palCnt+1:palCnt);
        carr[step] = -1;
        return;
    }
    if(x != sz-1) {
        carr[step-1] =  arr[x][y];
        RECURSION(x+1,y, step+1);
        carr[step-1] = -1;
        if(y != sz) {
            carr[step-1] = arr[x][y];
            RECURSION(x, y+1, step+1);
            carr[step-1] = -1;
        }
        return;
    }
    if(y != sz) {
        carr[step-1] = arr[x][y];
        RECURSION(x, y+1, step+1);
        carr[step-1] = -1;
    }
}

bool table::comp() {
    for(int i = 0; i < (sz*2)-1; i++)
        if(carr[i]!= carr[(sz*2)-i-2])
            return 0;
    return 1;
}
