/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>
#include <iomanip>

using namespace std;

bool check(long base, long num){
    long a = base;
    while (a<num){
        a = pow(double(a), double(base));
    }
    return a==num;
}

int main() {
    double n;

    #ifdef DEBUG
        n = 5;
    #else
        ifstream in;
        in.open("numbers.in");
        in>>n;
        in.close();
    #endif // DEBUG

    long R=0;

    if(n>=1 && n<4){
        R=1;
    } else {
        for(long b=4; b<=n; b+=1){
            int z=b%10;
            if (z==0) {
            } else if(z==1) {
                if (check(3, b)||check(7, b)||check(9, b)) {
                    R++;
                }
            } else if(z==2) {
                if (check(2, b)||check(8, b)) {
                    R++;
                }
            } else if(z==3) {
                if (check(3, b)||check(7, b)) {
                    R++;
                }
            } else if(z==4) {
                if (check(2, b)||check(4, b)||check(8, b)) {
                    R++;
                }
            } else if(z==5) {
                if (check(5, b)) {
                    R++;
                }
            } else if(z==6) {
                if (check(2, b)||check(4, b)||check(6, b)||check(8, b)) {
                    R++;
                }
            } else if(z==7) {
                if (check(3, b)||check(7, b)) {
                    R++;
                }
            } else if(z==8) {
                if (check(2, b)||check(8, b)) {
                    R++;
                }
            } else if(z==9) {
                if (check(3, b)||check(7, b)||check(9, b)) {
                    R++;
                }
            }
        }
    }
    #ifdef DEBUG
        cout<<R<<endl;
    #else
        ofstream out;
        out.open("numbers.out");
        out<<R<<endl;
        out.close();
    #endif // DEBUG
    return 0;
}
