/* GCC*/
#include <fstream>
#include <cmath>
using namespace std;
long long binpow(int a, int pow,int n)
{
    if (pow == 0)
        return 1;
    if (pow % 2 == 0)
    {
        long long x;
        x = binpow(a, pow/2,n);
        if (x > round(sqrt(n)) || x == -1)
            return -1;
        return x*x;
    }
    else
    {
        long long x;
        x=binpow(a,(pow-1)/2,n);
        if (x*round(sqrt(a)) > round(sqrt(n)) || x == -1)
            return -1;
        return x*x*a;
    }
}
int numpows(int n)
{
    int k = 1;
    int a,b;
    for(int i = 2;binpow(i,i,n) != -1; i++)
    {
        b = binpow(i,i,n);
        while (b != -1)
        {
            k++;
            b = binpow(i,b,n);
        }
    }
    return k;
}
int main()
{
    ifstream fin("numbers.in");
    int n;
    fin >> n;
    ofstream fout("numbers.out");
    fout << numpows(n) << endl;
    return 0;
    fin.close();
    fout.close();
}
