/* GCC */
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

struct myPair {
    int x;
    int y;
    int n;
};

operator < (myPair a, myPair b) {
    if (a.x < b.x) return true;
    if (a.x == b.x && a.y < b.y) return true;
    return false;
}

int main()
{
    ifstream in;
    ofstream out;
    in.open("polyline.in");
    out.open("polyline.out");
    int n;
    in >> n;
    vector <myPair> p;
    for (int i = 0; i < n; i++) {
        int xs, ys;
        in >> xs >> ys;
        myPair coords;
        coords.x = xs;
        coords.y = ys;
        coords.n = i + 1;
        p.push_back(coords);
    }
    sort(p.begin(), p.end());
    out << p[0].n;
    for (int i = 1; i < n; i++) {
        out << " " << p[i].n;
    }
    out << endl;
    in.close();
    out.close();
    return 0;
}
