 /* GCC */
#include<iostream>
#include<cmath>
#include<vector>
#include<fstream>

#define f first
#define s second

typedef long long ll;

using namespace std;

pair<int,int> a[2018];
pair<int,int> c[2017];

double dist(int x1, int y1, int x2, int y2, int x3, int y3)
{
    return (double)abs( ( ( (x2-x1)*y3 + (y1-y2)*x3 + y2*x1 - x2*y1) / sqrt( (x2-x1)*(x2-x1) + (y1-y2)*(y1-y2) ) ) );
    //return (double) abs( ((x1+x2)/2 - x3)*((x1+x2)/2 - x3) + ((y1+y2)/2 - y3)*((y1+y2)/2 - y3));
}


int main()
{
    ios::sync_with_stdio(0);
    ifstream fin("polyline.in");
    ofstream fout("polyline.out");
    int n;
    fin>>n;
    for(int i = 0;i<n;++i)
    {
        fin>>c[i].f>>c[i].s;
    }
    a[0] = make_pair(0,1); //a.push_back(make_pair(0,1));
    a[1] = make_pair(1,2); //a.push_back(make_pair(1,2));
    a[2] = make_pair(0,2); //a.push_back(make_pair(0,2));
    int cn = 3;
    for(int i = 3;i<n;++i)
    {
        double d = dist(c[a[0].f].f, c[a[0].f].s, c[a[0].s].f, c[a[0].s].s, c[i].f, c[i].s);
        int p = 0;
        for(int j = 0;j < cn;++j)
        {
            double d1 = dist(c[a[j].f].f, c[a[j].f].s, c[a[j].s].f, c[a[j].s].s, c[i].f, c[i].s);
            if(d1<d)
            {
                d = d1;
                p = j;
            }

            //cout<<i<<' '<<j<<' '<<p<<' '<<d1<<' '<<d<<'\n';
        }
        a[cn] = make_pair(a[p].f,i); //a.push_back(make_pair(a[p].f,i));
        a[cn+1] = make_pair(a[p].s,i); //a.push_back(make_pair(a[p].s,i));
        swap(a[cn+1],a[p]); //a.erase(p,1);
        cn++;
    }

    vector <int> ans;
    ans.push_back(0);
    cn--;
    /*for(int i = 0;i<n;++i)
    {
        cout<<a[i].f+1<<' '<<a[i].s+1<<'\n';
    }*/
    while(cn--)
    {
        int k = ans[ans.size()-1];
        for(int i = 0;i<n;++i)
        {
            if(a[i].f == k)
            {
                ans.push_back(a[i].s);
                a[i] = make_pair(-1,-1);
                break;
            }
            if(a[i].s == k)
            {
                ans.push_back(a[i].f);
                a[i] = make_pair(-1,-1);
                break;
            }
        }
    }
    //cout<<cn<<'\n';
    for(int i = 0;i<n;++i)
    {
        fout<<ans[i]+1<<' ';
    }
}
