
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class Runner {
	private static int[][] table;
	private static String in_fileName = "table.in";
	private static String out_fileName = "table.out";
	
	public static int firstNum;
	
	public static void main(String[] args) {
		
		try {
			firstNum = FileIO.tableParser(in_fileName, table);
		} catch (IOException e) {
			throw new IllegalArgumentException("  !");
		}
		
		
	}
}

class FileIO {
	/**
	 * @param fileName
	 * @param table
	 * @return <p>first number of file</p>
	 * @throws FileNotFoundException
	 * @throws IOException
	 */
	public static int tableParser(String fileName, int[][] table) throws FileNotFoundException, IOException {
		int firstNum;
		try (BufferedReader reader = new BufferedReader(new FileReader(fileName))) {
			firstNum = Integer.parseInt(reader.readLine());
			table = new int[firstNum][firstNum];
			
			String line;
			
			int counter = 0;
			while ((line = reader.readLine()) != null) {
				String[] res = line.split(" ");
				
				if (res.length != firstNum) throw new IllegalArgumentException("      !");
				
				for (int i = 0; i < res.length; ++i) {
					table[counter][i] = Integer.parseInt(res[i]);
				}
				
				counter++;
			}
			
			if (counter != firstNum) throw new IllegalArgumentException("     !");
		}
		
		return firstNum;
	}
}
