/* GCC */

#include <iostream>
#include <fstream>
#include <math.h>

using namespace std;


int n;
int table[100][100];

int64_t palpath(int x1, int y1, int x2, int y2)
{
    int64_t a = 0;

    if(x2<x1 || y2<y1)
        return 0;
    else
    {


        if(x1 == x2 && y1 == y2)
            a=1;
        else
        {
            if(table[x1][y1]==table[x2][y2])
            {
                if(x1<=n && x2>0)
                    a+=palpath(x1+1, y1, x2-1, y2);
                if(y1<=n && x2>0)
                    a+=palpath(x1, y1+1, x2-1, y2);
                if(x1<=n && y2>0)
                    a+=palpath(x1+1, y1, x2, y2-1);
                if(y1<=n && y2>0)
                    a+=palpath(x1, y1+1, x2, y2-1);

            }
            else
                return 0;
        }
    }

    return a;
}

void procInp()
{
    ifstream inp ("table.in");
    inp >> n;
    for(int a=0; a<n; a++)
        for(int b=0; b<n; b++)
            inp >> table[a][b];

    inp.close();
}

void procOutp(int64_t ans)
{
    ofstream outp ("table.out");
    outp << (ans - 101*trunc(ans/101));
    outp.close();
}

int main()
{


    procInp();

    int64_t ans;

    if(table[0][0] == table[n-1][n-1])
        ans=palpath(0,0,n-1,n-1);
    else
        ans=0;

    procOutp(ans);

    return 0;
}
