/* GCC */

#include <iostream>
#include <stdio.h>

using namespace std;

int a [101][101], b [101][101];

long long K(int p, int m)
{
    for (int i = 0; i < p; ++i)
    {
        b [i][0] = 1;
    }
    for (int j = 0; j < m; ++j)
    {
        b [0][j] = 1;
    }
    for (int i = 1; i < p; ++i)
    {
        for (int j = 0; j < m; ++j)
        {
            b [i][j] = b [i - 1][j] + b [i][j - 1];
        }
    }
    if (p == 0 && m == 0) return b [0][0];
    if (p == 0) return b [0][m - 1];
    if (m == 0) return b [p - 1][0];
    return b [p - 1][m - 1];
}

int main()
{
    freopen("table.in", "r", stdin);
    freopen("table.out", "w", stdout);
    int n;
    cin.tie(NULL);
    cin >> n;
    long long k = K(n, n), ans = k;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            cin >> a [i][j];
        }
    }
    for (int i = 0; i < n - 1; ++i)
    {
        for (int j = 0; j < n - 1; ++j)
        {
            if (i + j < n - 1)
            {
                if (a [i][j] != a [n - 1 - j][n - 1 - i]) ans -= K(n - j - i, n - i - j) * K(i, j) * K(i, j);
                if (n - 1 - i >= i && n - 1 - j >= j && a [i][j] != a [n - 1 - i][n - 1 - j])
                    ans -= K(n - 2 * i, n - 2 * j) * K(i, j) * K(j, i);
            }
        }
    }
    cout << ans % 101 << '\n';
}
