/* GCC */

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

vector<int> eraseEl(vector<int> a, int b){
    a.erase(a.begin()+a.size()-b);
    return a;
}

int main(){
    /*int u=10;
    ofstream fouts("table.in");
    fouts<<u<<endl;
    for(int i=0; i<u; i++){
        for(int z=0; z<u; z++){
            fouts<<1<<' ';
        }
        fouts<<endl;
    }
    fouts.close();*/
    ifstream fin("table.in");
    ofstream fout("table.out");


    //read
    int n, x, y;
    fin>>n;
    vector< vector<int> > arr(n, vector<int>(n));
    int i,z;
    for(i=0; i<n;i++){
        for(z=0; z<n; z++){
            fin>>arr[i][z];
        }
    }


    //first and last are different
    if (arr[0][0]!=arr[n-1][n-1]){
        fin.close();
        fout<<0<<endl;
        fout.close();
        return 0;
    }

    //helpers
    vector< vector<int> > stack(0);
    vector< vector<int> > stackxy(0); //0 - x, 1 - y
    vector<int> vec(0);
    vector<int> vecxy(0);

    vec.push_back(arr[0][0]);
    stack.push_back(vec);
    vec[0]=0;
    vec.push_back(0);
    stackxy.push_back(vec);


    //main part
    int ostacha=2, answer=0;
    /*if (n%2==1) ostacha=2;
     else ostacha=1;*/
    bool more=false; //more than a half
    while(stack.size()!=0){
        x=stackxy[0][0];
        y=stackxy[0][1];
        vec=stack[0];
        vecxy=stackxy[0];
        if (x==n-1 && y==n-1){
            answer++;
            if (answer==101) answer=0;
        }
        if (vec.size()>(2*n-1)/2) {
            more=true;
        }
        if (stackxy[0][0]<n-1){
            //down
            if(!more){
                stack.push_back(vec);
                stack[stack.size()-1].push_back(arr[x+1][y]);
                stackxy.push_back(vecxy);
                stackxy[stackxy.size()-1][0]++;
            } else {

                    if (arr[x+1][y]==vec[vec.size()-ostacha]){
                        stack.push_back(vec);
                        stack[stack.size()-1]=eraseEl(stack[stack.size()-1], ostacha);
                        //stack[stack.size()-1].erase(stack[stack.size()-1].end()-ostacha+1);
                        stackxy.push_back(vecxy);
                        stackxy[stackxy.size()-1][0]++;
                    }

            }
        }
        if (stackxy[0][1]<n-1){
            //right
            if(!more){
                stack.push_back(vec);
                stack[stack.size()-1].push_back(arr[x][y+1]);
                stackxy.push_back(vecxy);
                stackxy[stackxy.size()-1][1]++;
            } else {
                    if (arr[x][y+1]==vec[vec.size()-ostacha]){
                        stack.push_back(vec);
                        stack[stack.size()-1]=eraseEl(stack[stack.size()-1], ostacha );
                        stackxy.push_back(vecxy);
                        stackxy[stackxy.size()-1][1]++;
                    }
            }
        }
        stack.erase(stack.begin());
        stackxy.erase(stackxy.begin());
    }


    /*for(i=0; i<n;i++){
        for(z=0; z<n; z++){
            cout<<arr[i][z]<<' ';
        }
        cout<<endl;
    }*/
    fout<<answer<<endl;

    fin.close();
    fout.close();

    /*ofstream fouts("table.in");
    fouts<<100<<endl;
    for(i=0; i<100; i++){
        for(z=0; z<100; z++){
            fouts<<1<<' ';
        }
        fouts<<endl;
    }
    fout.close();*/

    return 0;
}
