""" Python 3 """

fin = open('table.in')
fout = open('table.out', 'w')

s = fin.read().split('\n')
n = int(s[0])
s = [i.split(' ') for i in s[1:]]

def pln(s):
    flag = True
    l = len(s)
    for i in range(l//2):
        if s[i] != s[l-i-1]:
            flag = False
            break
    return flag

def pmt(li):
    l = [i for i in range(2*n-2) if li[i]]
    index = n-2
    while l[index] == n-1+index: index -= 1
    l[index] += 1
    for i in range(index+1, n-1):
        l[i] = l[i-1] + 1
    li[:] = [0 for i in range(2*n-2)]
    for i in l:
        li[i] = 1

def wander(li):
    i = j = 0
    p = [s[i][j]]
    for k in li:
        if k:
            i += 1
        else:
            j += 1
        p.append(s[i][j])
    return p

count = 0

if s[0][0] == s[n-1][n-1]:

    path = []
    for i in range(2*n-2):
        path.append(1 if i < n-1 else 0)
    
    from math import factorial as f
    total = f(2*n-2)//f(n-1)**2 - 1

    if pln(wander(path)):
        count += 1
        
    for i in range(total):
        pmt(path)
        if pln(wander(path)):
            count += 1
        
    count %= 101
    
fout.write(str(count) + '\n')

fin.close()
fout.close()
