/* GCC */
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

vector<int> resheto(int n)
{
    vector<bool> isSimple(n + 1,true);
    vector<int> simple;
    for(int i = 2;i * i <= n;i++){
        if(isSimple[i]){
            for(int j = i * i;j <= n;j += i){
                isSimple[j] = false;
            }
        }
    }
    for(int i = 2;i <= n;i++){
        if(isSimple[i])
            simple.push_back(i);
    }
    return simple;
}

bool isSimple(int n)
{
    if(n < 2){
        return false;
    }
    if(n == 2)
        return true;
    if(n % 2 == 0)
        return false;
    int i = 3;
    while(i * i <= n){
        if(n % i == 0)
            return false;
        i += 2;
    }
    return true;
}
bool f(int n,int c)
{
    int cnt = 0;
    while(n % c == 0){
        n /= c;
        cnt++;
    }
    if(n == 1 && cnt >= 2){
        return true;
    }
    return false;
}
int main()
{
    ifstream fin("numbers.in");
    ofstream fout("numbers.out");
    int n;
    fin>>n;
    vector<int> r = resheto(n);
    int c = 1;
    for(int i = 2;i <= n;i++){
        if(isSimple(i))
            continue;
        for(int j = 0;j < r.size();j++){
            if(f(i,r[j])){
                c++;
                break;
            }
        }
    }
    fout<<c<<endl;
    return 0;
}
