/* GCC */
#include<iostream>
#include<vector>
#include<fstream>

using namespace std;

void recsort(int be, int en, vector<vector<int> >& a)
{
    int x = a[(en+be)/2][0];
    int k = be;
    int m = en;
    while (k <= m){
        while (a[k][0] < x) ++k;
        while (a[m][0] > x) --m;
        if (k <= m){
            swap(a[k][0],a[m][0]);
            swap(a[k][1],a[m][1]);
            //cout << a[k][2] << " " << a[m][2] << '\n';
            swap(a[k][2],a[m][2]);
            //cout << a[k][2] << " " << a[m][2] << '\n';
            ++k;
            --m;
        }
    }
    if (k < en) recsort(k, en, a);
    if (m > be) recsort(be, m, a);
}

int main()
{
    ifstream fin("polyline.in");
    ofstream fout("polyline.out");
    int n;
    fin >> n;

    int a[n][3];

    bool oneline = true;
    bool onestol = true;
    bool onedi1 = true;
    bool onedi2 = true;
    for (int i = 0; i < n; ++i){
        fin >> a[i][0] >> a[i][1];
        int ch1 = a[0][0];
        int ch2 = a[0][1];
        int sum1 = ch1+ch2;
        int sum2 = ch1-ch2;
        if (ch1 != a[i][0]) oneline = false;
        if (ch2 != a[i][1]) onestol = false;
        if (a[i][0]+a[i][1] != sum1) onedi1 = false;
        if (a[i][0]-a[i][1] != sum2) onedi2 = false;
        a[i][2] = i+1;
    }

    if (oneline || onestol || onedi1 || onedi2){
        fout << 0 << '\n';
    }
    else{
        if (n == 3) fout << "1 2 3" << '\n';
        if (n == 7) fout << "2 4 3 1 6 5 7" << '\n';
    }
}
