/* GCC */
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;


int main(){
    ifstream fin("polyline.in");
    int n;
    fin >> n;
    int coords[n][2];
    int iterators[n];
    for (int i = 0; i < n; i++){
        fin >> coords[i][0] >> coords[i][1];
        iterators[i] = i+1;
    }
    fin.close();

    for (int i = 0; i < n - 1; i++){
        for (int j = i + 1; j < n; j++){
            if (coords[j][0] < coords[i][0]){
                int temp = coords[i][0];
                coords[i][0] = coords[j][0];
                coords[j][0] = temp;

                temp = coords[i][1];
                coords[i][1] = coords[j][1];
                coords[j][1] = temp;

                temp = iterators[i];
                iterators[i] = iterators[j];
                iterators[j] = temp;
            }
        }
    }

    for (int i = 0; i < n - 1; i++){
        for (int j = i + 1; j < n; j++){
            if (coords[i][0] == coords[j][0]){
                if (coords[i][1] > coords[j][1]){
                    int temp = coords[i][0];
                    coords[i][0] = coords[j][0];
                    coords[j][0] = temp;

                    temp = coords[i][1];
                    coords[i][1] = coords[j][1];
                    coords[j][1] = temp;

                    temp = iterators[i];
                    iterators[i] = iterators[j];
                    iterators[j] = temp;
                }
            }
        }
    }

    ofstream fout("polyline.out");
    for (int i = 0; i < n - 1; i++){
        fout << iterators[i] << " ";
    }
    fout << iterators[n-1] << endl;
    fout.close();
    return 0;
}
