/* GCC */
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

int n;
int table[100][100];
long long answer = 0;

/*bool isPalindromic(vector<int> row){
    for (int i = 0; i < n-1; i++){
        if (row[i]!=row[2*n - 2 - i]) return false;
    }
    return true;
}*/

int main(){
    ifstream fin("table.in");
    fin >> n;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            fin >> table[i][j];
        }
    }
    fin.close();


    ofstream fout("table.out");
    if (table[0][0]!=table[n-1][n-1]){
        fout << 0 << endl;
        return 0;
    }


    vector<int> start;
    start.push_back(table[0][0]);

    vector<vector <int> > rows;
    rows.push_back(start);

    vector<pair<int, int> > coords;
    coords.push_back(make_pair(0, 0));


    while (!rows.empty()){
        int size = rows.size();
        for (int k = 0; k < size; k++){
            vector<int> row = rows[0];
            rows.erase(rows.begin());
            int i = coords[0].first;
            int j = coords[0].second;
            coords.erase(coords.begin());

            if (i + j == 2*n - 2){
                fout << size%101 << endl;
                fout.close();
                return 0;
              //  if (isPalindromic(row)) {
                //    answer++;
                //}
            } else {
                if (i < n-1){
                    row.push_back(table[i+1][j]);
                    if ((row.size()>n)&&(row[row.size() - 1] == row[2*n - row.size() - 1])){
                        rows.push_back(row);
                        coords.push_back(make_pair(i+1, j));
                    }
                    if (row.size() <= n){
                        rows.push_back(row);
                        coords.push_back(make_pair(i+1, j));
                    }
                }
                if (j < n-1){
                    if (i < n-1){
                        row.erase(row.end()-1);
                    }
                    row.push_back(table[i][j+1]);
                    if ((row.size()>n)&&(row[row.size() - 1] == row[2*n - row.size() - 1])){
                        rows.push_back(row);
                        coords.push_back(make_pair(i, j+1));
                    }
                    if (row.size() <= n){
                        rows.push_back(row);
                        coords.push_back(make_pair(i, j+1));
                    }
                }
            }
        }
    }

    fout << 0 << endl;
    fout.close();
    return 0;
}
