

import java.io.BufferedWriter;
import java.io.File;
import java.io.*;
import java.util.*;

public class numbers {

	private static final String INPUT_FILE = "D:/Olimp/WORK/Sobol/olimp/src/task1/numbers.in";
	
	private static final String OUTPUT_FILE = "D:/Olimp/WORK/Sobol/olimp/src/task1/numbers.out";
	
	public static void main(final String[] args) throws IOException {
		final int input = getInput();
		final int output = getOutput(input);
		writeOutput(OUTPUT_FILE, String.valueOf(output));
	}
	
	private static void writeOutput(final String filePath, final String output) {
		try (final BufferedWriter writer = new BufferedWriter(new FileWriter(filePath))) {
			writer.write(output);
		} catch (IOException e) {};
	}
	
	private static int getOutput(final int input) {
		int counter = 0;
		for (int i = 0; i < input; i++) {
			if (isAppropriate(i)) {
				counter++;
			}
		}
		return counter;
	}
	
	private static boolean isAppropriate(final int number) {
		if (number == 1) {
			return true;
		}
		for (int i = 2; i < number; i++) {
			int current = i;
			while (current <= number) {
				if (current == number) {
					return true;
				} else {
					current *= current;
				}
			}
		}
		return false;
	}
	
	private static int getInput() throws IOException {
		return new Scanner(new File(INPUT_FILE)).nextInt();
	}
	
}
