/* GCC */
#include <iostream>
#include <cstdio>

using namespace std;

long long mas [3000][3];

long long check1 (long long i, long long a, long long b){
    if (mas[i][1]>a)
         return 0;
    if (mas[i][1]<a)
        return 1;
    if (mas[i][2]>b)
        return 0;
    if (mas[i][2]<b)
        return 1;
    return 2;
}

void qsort (long long l, long long r){
    long long lefth = l;
    long long right = r;
    long long midle1 = mas[(l+r)/2][1];
    long long midle2 = mas[(l+r)/2][2];
    while (lefth<=right){
        while (check1(lefth,midle1,midle2)==1) lefth++;
        while (check1(right,midle1,midle2)==0) right--;
        if (lefth<=right)
        {
            swap(mas[lefth][0],mas[right][0]);
            swap(mas[lefth][2],mas[right][2]);
            swap(mas[lefth][1],mas[right][1]);
            right--;
            lefth++;
        }
    }
    if (l<right) qsort(l,right);
    if (lefth<r) qsort(lefth,r);
}



long long n;
int main(){
    freopen ("polyline.in","r",stdin);
    freopen ("polyline.out","w",stdout);
    cin>>n;
    for (int i=1; i<=n; i++){
        cin>>mas[i][1]>>mas[i][2];
        mas[i][0]=i;
    }
    qsort(1,n);
    long long x=0;
    for (int i=1; i<n-2; i++)
    {
        if ((mas[i+1][1]*mas[i+2][2]-mas[i+2][2]*mas[i][1]-mas[i][2]*mas[i+1][1])!=(mas[i+2][1]*mas[i+1][2]-mas[i][2]*mas[i+2][1]-mas[i][1]*mas[i+1][2]))
            x++;
    }
    if (x!=0){
        for (int i=1; i<n; i++){
            cout<<mas[i][0]<<" ";
        }
        cout<<mas[n][0]<<endl;
    } else
    {
        cout<<0<<endl;
    }
    return 0;
}

