/* GCC */
#include <iostream>
#include <fstream>
using namespace std;
/*template<typename T>
class BITARRAY
{
    unsigned vsize, sz;
    T* arr;
public:
    BITARRAY(unsigned asize)
    {
        vsize = sizeof(T);
        sz = asize;
        unsigned tas = asize / vsize + (bool)(asize % vsize);
        arr = new T[tas];
        for (unsigned i = 0; i < tas; i++)
            arr[i] = 0;
    }
    bool getbit(unsigned index)
    {
        return (arr[index / vsize] >> (index % vsize)) & 1;
    }
    BITARRAY& setbit(unsigned index, bool bit)
    {
        if (bit)
            arr[index / vsize] |= 1 >> index;
        else
            arr[index / vsize] &= 0 >> index;
            return this;
    }
    BITARRAY& operator++()
    {
        unsigned index = sz;
        bool stop;
        do
        {
            stop = setbit(index, !getbit(index)).getbit(index);
            index--;
        }
        while(!stop);
        return *this;
    }
};*/
class BITARRAY
{
public:
    unsigned SIZE;
    bool* bl;
    BITARRAY(unsigned Size)
    {
        SIZE = Size;
        bl = new bool[SIZE];
        for (unsigned i = 0; i < SIZE; i++)
            bl[i] = false;
    }
    bool already()
    {
        for (unsigned i = 0; i < SIZE; i++) if (!bl[i]) return false;
        return true;
    }
    void inc()
    {
        unsigned index = SIZE;
        do
        {
            bl[index] = !bl[index];
        }
        while(index && !bl[index--]);
    }
};
void disp(unsigned short** td, int n, unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, unsigned rez)
{
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < n; j++)
        {
            cout << '\t' << td[i][j];
            if (i == x1 && j == y1)
                cout << "[1]";
            if (i == x2 && j == y2)
                cout << "[2]";
        }
        cout << endl;
    }
    cout << rez << endl;
}
int main()
{
    ifstream fin("table.in");
    ofstream fout("table.out");
    unsigned short n;
    unsigned long long rez = 0;
    fin >> n;
    unsigned short** arr = new unsigned short*[n];
    for (unsigned short i = 0; i < n; i++)
    {
        arr[i] = new unsigned short[n];
        for (unsigned short j = 0; j < n; j++)
            fin >> arr[i][j];
    }
    //BITARRAY<unsigned long long> ba(2 * n - 1);
    BITARRAY barr(n * 2 - 1);
    for (; !barr.already(); barr.inc())
    {
        unsigned bhs = barr.SIZE / 2;
        bool plndrm = true;
        unsigned short x1 = 0, x2 = n - 1, y1 = 0, y2 = n - 1, itr1 = 0, itr2 = barr.SIZE - 1;
        for (; itr1 < bhs && itr2 > bhs; itr1++, itr2--)
        {
            if (x1 >= n || y1 >= n || y1 < 0 || y2 < 0)
            {
                plndrm = false;
                break;
            }
            if (arr[x1][y1] != arr[x2][y2])
            {
                plndrm = false;
                break;
            }
            disp(arr, n, x1, y1, x2, y2, rez);
            cin.get();
            if (barr.bl[itr1])
                x1++;
            else
                y1++;
            if (barr.bl[itr2])
                x2--;
            else
                y2--;
        }
        if (plndrm && x1 == x2 && y1 == y2)
            rez++;
        disp(arr, n, x1, y1, x2, y2, rez);
        cin.get();
    }
    fout << rez;
    fin.close();
    fout.close();
    return 0;
}
