/* GCC */

#include <cstdio>
#include <algorithm>
#include <vector>
#include <utility>
#include <stdint.h>
#include <inttypes.h>

using namespace std;

#define NAME "numbers"

int kount[100000] = {};

inline int64_t pow(int64_t x, int64_t p)
{
    int64_t x1 = x;
    for (int i = 1; i < p; ++i) {
        x *= x1;
        if (x > 1000000000LL)
            return 1000000001LL;
    }

    return x;
}

int nums[] = {1, 4, 16,27, 256, 3125, 46656, 65536, 823543, 16777216, 387420489};

int main()
{
    freopen(NAME".in", "r", stdin);
    freopen(NAME".out", "w", stdout);

    int n;
    scanf("%d", &n);

    for (int i = 0; i < 11; ++i) {
        if (nums[i] > n) {
            printf("%d\n", i);
            return 0;
        }
    }
    printf("%d\n", 11);

    return 0;
}
