/* GCC */

#include <iostream>
#include <stdio.h>

using namespace std;

int n;
int graph[102][102];
int que[204] = {0};
long ans = 0;

bool polyndrom(){
    int m = 2 * n - 1;
    for(int i = 1; i <= m / 2; ++i){
        if(que[i] != que[m - i + 1])
            return false;
    }
    return true;
}

void dfs(int i, int j, int q){
    que[q] = graph[i][j];
    if(i == j && i  == n){
        if(polyndrom()){
            ++ans;
            ans = ans % 101;
        }

    }
    else{
        if(i < n)
            dfs(i + 1, j, q + 1);
        if(j < n)
            dfs(i, j + 1, q + 1);
    }
    que[q] = 0;
}

int main()
{
    freopen("table.in", "r", stdin);
    freopen("table.out", "w", stdout);

    cin >> n;

    for(int i = 1; i <= n; ++i)
        for(int j = 1; j <= n; ++j)
        cin >> graph[i][j];

    dfs(1, 1, 1);

    cout << ans << endl;

    return 0;
}
