/* GCC */
#include <fstream>

using namespace std;
int wayfinder(int h1,int l1,int h2,int l2,int arrNum[101][101])
{
    int num = 0;
    if (l2 > l1 && h2 >= h1)
    {
        if (arrNum[h1][l1 + 1] == arrNum[h2-1][l2])
            num+=wayfinder(h1,l1+1,h2-1,l2,arrNum);
        if (arrNum[h1][l1 + 1] == arrNum[h2][l2-1])
            num += wayfinder(h1,l1+1,h2,l2-1,arrNum);
    }
    if (h2 > h1 && l2 >= l1)
    {
        if (arrNum[h1+1][l1] == arrNum[h2-1][l2])
            num+=wayfinder(h1+1,l1,h2-1,l2,arrNum);
        if (arrNum[h1+1][l1] == arrNum[h2][l2-1])
            num+=wayfinder(h1+1,l1,h2,l2-1,arrNum);
    }
    if (h1 == h2 && l1 == l2)
        return 1;
    return num % 101;

}
int main()
{
    int n;
    ifstream fin("table.in");
    fin >> n;
    int arrNum[101][101];
    for(int i = 0;i < n;i++)
        for (int j = 0;j < n; j++)
            fin >> arrNum[i][j];
    ofstream fout("table.out");
    if (arrNum[0][0]== arrNum[n-1][n-1])
        fout << wayfinder(0,0,n-1,n-1,arrNum) << endl;
    else
        fout << 0 << endl;
    fin.close();
    fout.close();
    return 0;
}
