/* GCC */
#include <iostream>
#include <cstdio>

using namespace std;

int n[100][100];

int rez(int x, int y, int stop)
{
    if (x + y != stop)
    {
        int ans = 0;

        if (n[x + 1][y] != -1)
            ans += rez(x + 1, y, stop);

        if (n[x][y + 1] != -1)
            ans += rez(x, y + 1, stop);

        return ans;
    }
    else
    {
        int ans = 0;

        if (n[x + 1][y] != -1)
            ans ++;

        if (n[x][y + 1] != -1)
            ans ++;

        return ans;
    }

}

int main()
{
    freopen("table.in", "r", stdin);
    freopen("table.out", "w", stdout);
    int k;
    cin >> k;

    for (int i = 0; i < k; i++)
    {
         for (int j = 0; j < k; j++)
         {
             cin >> n[i][j];
         }
    }

    for (int i = 0; i < k; i++)
    {
         for (int j = 0; j < k; j++)
         {
             if (n[i][j] != n[k - 1 - j][k - 1 - i])
             {
                 n[i][j] = -1;
                 n[k - 1 - j][k - 1 - i] = -1;
             }
         }
    }

    cout << rez(0, 0, k - 2) << endl;

    return 0;
}
