""" Python 3 """

fin = open("table.in","r")
fout = open("table.out","w")

n = int(fin.readline())
table = []

def findWays(row,col):
    neighbours=findNeighbours(row,col)
    if [n-1,n-1] in neighbours:
        return [[n-1,n-1],[row,col]]
    else:
        currWays = []
        for i in neighbours:
            neighbour_way = findWays(i[0],i[1])
            for j in neighbour_way:
                temp=j
                temp.append([row,col])
                currWays.append(temp)
        return currWays

def findNeighbours(row,column):
    neighbours = []
    if row!=n-1:
        neighbours.append([row+1,column])
    if column!=n-1:
        neighbours.append([row,column+1])
    return neighbours

for i in range(n):
    table.append(fin.readline().split())

notCorrect = findWays(0,0)
ways = []

i=0

while i<len(notCorrect):
    temp = [[notCorrect[i][0],notCorrect[i][1]]]
    temp.append([notCorrect[i+1][0],notCorrect[i+1][1]])
    for j in range(2,len(notCorrect[i])):
        temp.append(notCorrect[i][j])
    i+=2
    ways.append(temp)

palindromWays=0
for i in ways:
    currWay = []
    for j in i:
        currWay.append(table[j[0]][j[1]])

    if currWay==currWay[::-1]:
        palindromWays+=1

fout.write(str(palindromWays)+"\n")

fin.close()
fout.close()
