
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.omg.CORBA.portable.UnknownException;

public class Runner {
	public static String in_fileName  = "numbers.in";
	public static String out_fileName  = "numbers.out";
	public static int num;
	public static int count = 0;
	public static List<Integer> powers = new ArrayList<Integer>();
	
	public static void main(String[] args) {
		
		try {
			num = FileIO.getNumFromFile(in_fileName);
		} catch(IOException e) {
			throw new IllegalArgumentException("  .");
		}
		
		for (int i = 1; i <= num; i++) {
			boolean choosed = false;
			for (int j = 1; j <= i; j++) {
				if (choosed) break;
				
				//double buffer = j;
				double pow = j;
				
				while(true) {
					System.out.println(j + " " + pow);
					if (Math.pow(j, pow) == i) {
						count++;
						choosed = true;
						break;
					}
					else if (Math.pow(j, pow) < i && j != 1){
						pow = Math.pow(pow, pow);
					}
					else {
						break;
					}
				}
			}
			
		}
		
		try {
			FileIO.writeToFile(count, out_fileName);
		} catch(IOException e) {
			throw new UnknownException(e);
		}
		
		//System.out.println(count);
	}
}

class FileIO {			
	public static int getNumFromFile(String fileName) throws FileNotFoundException, IOException {
		int num;
		
		try (BufferedReader reader = new BufferedReader(new FileReader(fileName))) {
			String line = reader.readLine();
			
			String[] res = line.split(" ");
			if (res.length != 1) throw new IllegalArgumentException("     !   ");
			
			if (Integer.parseInt(res[0]) > Math.pow(10, 9)) throw new IllegalArgumentException(res[0] = " > 10^9");
			
			return Integer.parseInt(res[0]);
		} 
	}
	
	public static void writeToFile(int toWrite, String fileName) throws IOException {
		FileWriter writer = new FileWriter(new File(fileName), false);
		writer.write(Integer.toString(toWrite));
		writer.flush();
	}
}

